# aitom-ajax library
Fasáda pro knihovnu ``nette.ajax.js`` umožňující její použití jako ES6 modulu. 
Knihovna také zajištuje její správnou konfigurraci pro potřeby Aitomu. Je implementována jako singleton s autoinicializací.

## Instalace
````
npm i --save aitom-ajax
````

## Použití
K použití je knihovnu vždy potřeba nejprve importovat. 
````
import ajax from 'aitom-ajax';
````

Díky její implementaci jako singleton, nezáleží na počtu importů v různých modulech, vždy se importuje ta samá instance.

### Extensions
Stejně jako u ``nette.ajax.js`` je i u ``aitom-ajax`` hlavním úkolem přidávání rozšíření. To se může buď provádět úplně stejně jako u originální knihovny. Například takto:
````
ajax.ext('unikatni-nazev-rozsireni', {
    'success': () => {
        // Do something when ajax is complete succesfully
    }
});
````

Nebo můžete použít vylepšené metody ``àddExt``, která vytvoří unikátní název pro rozšíření automaticky. Například takto:
````
ajax.addExt({
    'success': () => {
        // Do something when ajax is complete succesfully
    }
});
````

#### Přehled obektu rozšíření
Objekt pro rozšíření je naprosto stejný jako u [originální knihovny](https://github.com/vojtech-dobes/nette.ajax.js):

|name|arguments|description|
|--- |--- |--- |
|``load``|``requestHandler``|Should contain ajaxification. requestHandler can be bound to UI events to initiate AJAX request.|
|``before``|``jqXHR``, ``settings``|Called immediatelly before AJAX request execution. If FALSE is returned, request won't start.|
|``start``|``jqXHR``, ``settings``|Called immediatelly after start of AJAX request.|
|``success``|``payload``, ``status``, ``jqXHR``, ``settings``|Called after successful completion of AJAX request. Equivalent to $.ajax( ... ).done( ....|
|``complete``|``jqXHR``, ``status``, ``settings``|Called after every AJAX request completion. Equivalent to $.ajax( ... ).always( ....|
|``error``|``jqXHR``, ``status``, ``error``, ``settings``|Called in case of failure of AJAX request. Equivalent to $.ajax( ... ).fail( ....|



